----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:10:01 05/16/2012 
-- Design Name: 
-- Module Name:    memory - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity memory is
    Port ( memwrite : in  STD_LOGIC;
			  address : in  STD_LOGIC_VECTOR(2 downto 0);
			  data_in: in STD_LOGIC_VECTOR(7 downto 0);
			  clk		: in STD_LOGIC;
           header : out  STD_LOGIC_VECTOR (7 downto 0);
           data1 : out  STD_LOGIC_VECTOR (7 downto 0);
           data2 : out  STD_LOGIC_VECTOR (7 downto 0);
           data3 : out  STD_LOGIC_VECTOR (7 downto 0);
           data4 : out  STD_LOGIC_VECTOR (7 downto 0));
end memory;

architecture Behavioral of memory is
signal header_mem: std_logic_vector(7 downto 0);
signal data1_mem: std_logic_vector(7 downto 0);
signal data2_mem: std_logic_vector(7 downto 0);
signal data3_mem: std_logic_vector(7 downto 0);
signal data4_mem: std_logic_vector(7 downto 0);
begin
process(clk,memwrite,data_in,address)
begin
	if(clk='1' and clk'EVENT)then
		if(memwrite='1')then--writing to the memory block
			case address is
				when "000" => header_mem<=data_in;
				when "001" => data1_mem<=data_in;
				when "010" => data2_mem<=data_in;
				when "011" => data3_mem<=data_in;
				when "100" => data4_mem<=data_in;
				when others => NULL;
			end case;
		end if;
	end if;
	header<=header_mem;
	data1<=data1_mem;
	data2<=data2_mem;
	data3<=data3_mem;
	data4<=data4_mem;
end process;
end Behavioral;

